#As it is traditional to do so all the extra functionality desired for this turtle race is imported at the start.
#All the particular functionality utilised will comes pre-installed on a default installation of Python.
import time
import turtle
from turtle import Turtle
from random import randint

#Setting up the pop-up window! And placing the title words in the centre top of the Python Turtle Graphics Window
#The function turtle.penup() effectively is lifting the robot turtle off the page and moving it, thus no pen line
window = turtle.Screen()
window.title("Turtle Racing Occuring in this Pop-Up Window!")
turtle.bgcolor("Green")
turtle.color("White")
turtle.speed(0)
turtle.penup()
turtle.setpos(-420, 260)
turtle.write("Come one, Come all! It is Turtle Racing Time!", font=("Arial", 30, "bold"))
turtle.penup()

#Adding some dirt to the base, This is similar to the star example above using the turtle.begin_fill() and is similar to drawing with a CNC machine.
#The starting point is decided on, the turtle is put onto the page and then movement commands are given to the robot turtle. 
turtle.setpos(-280, 225)
turtle.color('Brown')
turtle.begin_fill()
turtle.pendown()
turtle.forward(520)
turtle.right(90)
turtle.forward(445)
turtle.right(90)
turtle.forward(520)
turtle.right(90)
turtle.forward(445)
turtle.end_fill()

#Create a finishing line! Every turtle race needs one
#This used the turtle.stamp() functionality which when set like below lets you stamp white squares  
stamp_size = 20
square_size = 15.5
finish_line = 180

turtle.color('white')
turtle.shape('square')
turtle.shapesize(square_size / stamp_size)
turtle.penup()

#Now to make the finish line look checkered! It uses two loops to fill fourteen white stamp sections of colour

for i in range(14):
    turtle.setpos(finish_line, (211 - (i * square_size * 2)))
    turtle.stamp()

for j in range(14):
    turtle.setpos(finish_line + square_size, ((211 - square_size) - (j * square_size * 2)))
    turtle.stamp()

#And with all the above the field is now set!
#Now it is time to get our robot turtle competitors ready!
#Robot Turtle Number One, aka Franklin. Think of below as the stat blocks for the starting location and colour of turtles.

turtle1 = Turtle()
turtle1.speed(0)
turtle1.color("Black")
turtle1.shape("turtle")
turtle1.penup()
turtle1.goto(-275, 140)
turtle1.pendown()

#Turtle Number Two, aka Sonik (possibly a hedgehog in disguise)

turtle2 = Turtle()
turtle2.speed(0)
turtle2.color("Yellow")
turtle2.shape("turtle")
turtle2.penup()
turtle2.goto(-275, 60)
turtle2.pendown()

#Turtle Number Three, aka Michelangelo

turtle3 = Turtle()
turtle3.speed(0)
turtle3.color("lightblue")
turtle3.shape("turtle")
turtle3.penup()
turtle3.goto(-275, -20)
turtle3.pendown()

#Turtle Number Four, aka Crush

turtle4 = Turtle()
turtle4.speed(0)
turtle4.color("Orange")
turtle4.shape("turtle")
turtle4.penup()
turtle4.goto(-275, -110)
turtle4.pendown()

#And with that our competitors are on the Field!

#Pauses the game for three seconds so that all the turtles and all the bets can be wagered ready for the race!
time.sleep(3)

#This loop decides the end of the race. The end of the race happens once i reaches 145 iterations.  
#Most races will be over by this point. Movement speed of the turtles is also decided here
#If you wanted to program in an unfair advantage this is the spot to do it. 

for i in range(145):
    turtle1.forward(randint(1,5))
    turtle2.forward(randint(1,5))
    turtle3.forward(randint(1,5))
    turtle4.forward(randint(1,5))

#Finally a simple and easy way to get out of window is coded in below. By clicking anywhere on the window
#You can exit the application

turtle.exitonclick()
